/**
 * \file TPI_driver.c
 *
 * \brief TPIʐMpײ ٰ
 *
 * ̧قTPIʐMɕKvȊ֐܂݂܂B
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "TPI_driver.h"

volatile uint8_t nvm_status =0X80;

/* TPIʐMp߰ ݂ */
void tpi_init (void)
{
	DDRD = (1<<TPI_RESET)|(1<<TPI_CLK)|(1<<TPI_DATA_TX);
	PORTD |=(1<<TPI_RESET)|(1<<TPI_CLK);
}

/* 㑱钼񌮍}߂𑗐M
** NVM۸ݸޗp
** nvm_key : ]̂߂NVM_PROGRAM_ENABLEێϐ */
void send_skey (uint64_t nvm_key)
{
	tpi_send_byte(SKEY);
	while(nvm_key)
	{
		tpi_send_byte(nvm_key & 0xFF);
		nvm_key>>=8;
	}
}

/* TPIڼ޽ǂݍ݁ANVM(NVMEN=1)ȂA0x02ԂׂłB
** Ȃ0x00Ԃ܂B */
void read_tpi_status (void)
{
	tpi_send_byte(SLDCS | TPISR);
	tpi_idle(idle_clock);
 	tpi_status = tpi_receive_byte();
}

/* TPIwڼ޽GT[2:0]ޯĂB͎M삩瑗M֕ύX
** ɕKvȱَԂ`܂B
** time : ݒ肳ׂی쎞Ԓl
*/
void set_gaurd_time (uint8_t time)
{
	uint8_t powof2=1;

	tpi_send_byte(SSTCS |TPIPCR);
	tpi_send_byte(time);
	/* ݒ肷ی쎞ԂɊÂĕKvȱ ۯvZ */
	for(uint8_t i=0; i<(~time & 0x07); i++) powof2 *=2;
	idle_clock = (time==GAURD_TIME_0) ? 2 : (powof2+2);
}

/* TPIwڼ޽GT[2:0]ޯĂǂށB͎M삩瑗M֕ύX
** ɕKvȱَԂ̌ݒlłB */
void read_gaurd_time(void)
{
	tpi_send_byte(SLDCS |TPIPCR);
	tpi_idle(idle_clock);
	gaurd_time= tpi_receive_byte();
}

/* TPIڼ޽ǂݍ݁B0x80ԂׂłB */
void read_tpi_id(void)
{
	tpi_send_byte(SLDCS |TPIIR);
	tpi_idle(140);
	tpi_id = tpi_receive_byte();
}

/* TPIʐMBTPI IDǂݍ݁Aی쎞ԐݒA񌮑oɂNVM۸
   ދATPIԌ܂݂܂B */
void tpi_enable()
{
	tpi_init();
	tpi_comm_init();

	hold_reset_low();
	_delay_us(90);
	hold_data_high();
	tpi_receive_disable();
	tpi_transmit_enable();
	tpi_idle(50);

	read_tpi_id();
	set_gaurd_time(GAURD_TIME_128);
	read_gaurd_time();
	send_skey(NVM_PROGRAM_ENABLE);
	while(!tpi_status) 
	{
		read_tpi_status();
	}
}

/* 3޲Ă޲IDǂݍ */
void read_device_id (void)
{
	for(uint8_t bytes_read = 0; bytes_read <DEV_ID_SIZE;bytes_read++)
	{
		send_nvm_command(NVMCMD_NO_OPERATION);
		send_nvm_address(DEV_ID_START + bytes_read);
		dev_id[bytes_read] = read_nvm_byte();
	}
}

/* {޲ēǂݍ */
void read_lockbyte (void)
{
		send_nvm_command(NVMCMD_NO_OPERATION);
		send_nvm_address(NVM_LOCK_BITS_START );
		lock_byte[1] = read_nvm_byte();
}

/* {޲ď
** lockbyte : ݒ肳ׂ{޲ */
void program_lockbyte (uint8_t lockbyte)
{
	send_nvm_address(NVM_LOCK_BITS_START );
	send_nvm_command(NVMCMD_MEMORY_WRITE);
	write_nvm_word(0xFF00 | lockbyte);
	while(is_nvm_busy());
}

/* `Ԑݒ޲(˭ ޲)ǂݍ */
void read_config_byte0 (void)
{
	send_nvm_command((uint8_t)NVMCMD_NO_OPERATION);
	send_nvm_address(CONF_BITS_START);
	config_byte_0 =	read_nvm_byte();
}

/* `Ԑݒ̈ */
void erase_config_byte0 (void)
{
	send_nvm_address(CONF_BITS_START);
	send_nvm_command((uint8_t)NVMCMD_SECTION_ERASE);
	write_nvm_word(0xFFFF);
	while(is_nvm_busy());
}

/* `Ԑݒ޲(˭ ޲)
** config_byte : ׂ˭ޒl
*/
void program_config_byte0 (uint8_t config_byte)
{
	uint8_t i=0;

	do{
		send_nvm_address(CONF_BITS_START +(i*2));
		send_nvm_command((uint8_t)NVMCMD_MEMORY_WRITE);
		write_nvm_word(0XFF00 | config_byte);
		i++;
		if(words_to_write -i) tpi_idle(12);
	}while(i<words_to_write);
	while(is_nvm_busy());
}

/* Z޲0(iOSCCALl)ǂݍ */
void read_calib_byte0 (void)
{
	send_nvm_command((uint8_t)NVMCMD_NO_OPERATION);
	send_nvm_address(CALIB_BITS_START);
	calib_byte_0 =	read_nvm_byte();
}

/* ۸їp؂1ꏑ
** nvm_address : ׂ ڽ
** code_word : ׂް
*/
void program_code_word (uint16_t nvm_address,uint16_t code_word)
{
	send_nvm_address(nvm_address);
	send_nvm_command(NVMCMD_MEMORY_WRITE);
	write_nvm_word(code_word);
	if(words_to_write > 1) tpi_idle(12);
	while(is_nvm_busy());
}

/* ۸їp؂1ǂݍ
** nvm_address : ǂ܂ׂ ڽ
*/
uint8_t read_code_byte (uint16_t nvm_address)
{
	volatile uint8_t nvm_byte;
	send_nvm_command((uint8_t)NVMCMD_NO_OPERATION);
	send_nvm_address(nvm_address);
	nvm_byte =	read_nvm_byte();
	return nvm_byte;
}

/* ޗ̈BߏƓł͂܂B */
void erase_code_section (void)
{
	send_nvm_address(NVM_PROG_MEM_START);
	send_nvm_command(NVMCMD_SECTION_ERASE);
	write_nvm_word(0XFFFF);
	while(is_nvm_busy());
}

/* ߏ */
void chip_erase (void)
{
	send_nvm_address(NVM_PROG_MEM_START);
	send_nvm_command(NVMCMD_CHIP_ERASE);
	write_nvm_word(0xFFFF);
	while(is_nvm_busy());
}

/* NVMCSRǂݍ݂ɂNVMZ */
bool is_nvm_busy (void)
{
	tpi_send_byte(SIN |((NVMCSR & 0XF0)<<1) | (NVMCSR & 0X0F));
	tpi_idle(idle_clock);
	nvm_status = tpi_receive_byte();
	if(nvm_status == 0x80)
	{
		return true;
	}
	else
	{
		return false;
	}
}

/* TPI֎~ */
void tpi_disable()
{
	PORTD |=(1<<TPI_RESET);					// RESETJ
	UCSR1B &=(~(1<<RXEN1));
	UCSR1B &=(~(1<<TXEN1));
}

/* I񂾕ی쎞Ԃ̊Ա */
void tpi_idle(uint8_t gaurd_time)
{
	for(uint8_t i=0;i<gaurd_time;i++)
	{
		while (PIND & (1 << TPI_CLK));
		while (!(PIND & (1 << TPI_CLK)));
	}
}
